/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/
/* Variables ----------------------------------------------------------------*/
extern void Interrupt_Configuration(void);
/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main(void)
{
    Delay_Init();
    USART_Printf_Init(115200);
    KEY_AND_LEDIO_Init();               //ָʾIO
    USBDInit();                         //USBʼ
    Motor_Prameter_Define(&MBase_M);    //
    Motor_BaseCal_M(&MBase_M);          //ֵ
    Global_Status_Initial();            //ȫ״̬ʼ

    PID_Prameter_Define(&SpeedRegStruc_M,&dCurrRegStruc_M,&qCurrRegStruc_M);//תٵ
    PID_ParaBase_Cal_M(&MBase_M,&SpeedRegStruc_M,&dCurrRegStruc_M,&qCurrRegStruc_M);//תٵ

    HALL_Timer_Init();//HALLʹòʼ
    HALL_Parameter_Define(&MBase_M,&HALL_Para_M,&HALL_Cal_M,&HALL_SpeedBuffPara_M,&HALL_Status_M);//HALLʹòʼ
    HALL_Paramter_Cal (&MBase_M,&HALL_Para_M,&HALL_Cal_M,&HALL_SpeedBuffPara_M);

    Protection_and_Emergency_Init();                        //زʼ
    SVPWM_Paramter_Init(&SVPWM_Cal_M,MBase_M.Vbase);        //SVPWMʼ
    SVPWM_Timer_Configure(TIM1);                            //SVPWMʹöʱGPIOADCʼ
    ADC_Parameter_Init(&ADC_M,MBase_M.Ibase);               //ADCʼ
    ADC_Configure(&ADC_M,ADC1,TIM1);                        //ADC
    ADC_Status_Init (&ADC_M,ADC1,TIM1);                     //ADC״̬ʼ

    Timer3_Init();                                          //öʱʼ
    Timer2_Init();                                          //תٻʱʼ
    Interrupt_Configuration();                              //жóʼ

    //ʱʹ
    TIM_Cmd(TIM1, ENABLE);
    TIM_Cmd(TIM2, ENABLE);
    TIM_Cmd(TIM3, ENABLE);
    printf("HALL_MOTOR\r\n");

    while(1)
    {
        SysDelayOvertimeDispose();  //ʱִк
        Key_Press_Check();          //¼
        Key_Release_Check();        //ͷż
        Motor_Operation_Process();  //
        deal_sendMonitorData();     //ʾݷ
     }
}
