/* Define to prevent recursive inclusion ------------------------------------*/
#ifndef __M8_PROTECTION_H
#define __M8_PROTECTION_H

/* Includes -----------------------------------------------------------------*/
/* Exported types -----------------------------------------------------------*/
/* Exported constants -------------------------------------------------------*/
//ϱֲ
#define SYSTEM_FAULT_HOLDING_TIME       30      //ϴʱ(unit-0.01s)
#define SYSTEM_FAULT_HOLDING_FREQ       2000    //ϴжƵ(unit-Hz)

//
#define INST_PHASEOC_THRE_M       _IQ(1.1)      //˲ʱֵ(unit-A_per)
#define INST_PHASEOC_CNT_THRE_M   (uint16_t)15       //˲ʱжֵ

//ĸߵѹ
#define DCBUS_OVER_VOLT_THRE    _IQ18(1.2)      //ĸ߹ѹֵ(unit-V_per)
#define DCBUS_UNDER_VOLT_THRE   _IQ18(0.7)      //ĸǷѹֵ(unit-V_per)
#define DCBUS_OVER_VOLT_CNT     (uint16_t)100        //ĸ߹ѹжϴֵ
#define DCBUS_UNDER_VOLT_CNT    (uint16_t)100        //ĸǷѹжϴֵ

/* Exported variables -------------------------------------------------------*/
extern uint16_t FaultHoldingCnt_M;                  //ϴֵ
extern InstPhaseOC_Type  InstPhaseOC_M;        //˲ʱ
extern DCbusProtection_Type DCBusProtecion_M;  //ĸߵѹ

/* Exported macro -----------------------------------------------------------*/
/* Exported functions -------------------------------------------------------*/
//Ϻͱسʼ
void Protection_and_Emergency_Init (void);

//϶
void Protection_SetFault(uint16_t Fault_type);

//,ɸλ
void Protction_Fault_Reset_M(void);

//˲ʱж
Truth_Verify_Type Phase_Ins_OverCurrent_Verify (Component_3S_Type *PhaseABC, InstPhaseOC_Type * InstOC);

//ѹǷѹж
void DCBus_Protecion(_iq18 DCVolt, DCbusProtection_Type *DCbusProtec);

//۲תٳж
void Speed_Outrange_Verify(_iq24 Speedref, _iq24 Speedact, Observer_Status_Type *Status);

//תٿɿж
Truth_Verify_Type Speed_Reliable_Verify(BuffPara_Type *Buffpara,_iq24 *Buffer,_iq24 Averspeed,_iq24 Threshold);

//תȶж
void Speed_Stable_Verify(Observer_Status_Type *Status,_iq24 Speedact);


void Motor_Stall_Verify2(_iq24 Speedref, _iq24 Speedact , _iq24 Iqref, Observer_Status_Type *Status);

//תж
void Motor_Reverse_Verify(_iq24 Speedref, _iq24 Speedact, Observer_Status_Type *Status);


void Speed_Converged_Verify2(_iq24 Speedref,_iq24 Speedact,Observer_Status_Type *Status);

#endif
